-------------------------------------------------------------------------------
--
-- Copyright (C) 2014
-- ASTRON (Netherlands Institute for Radio Astronomy) <http://www.astron.nl/>
-- JIVE (Joint Institute for VLBI in Europe) <http://www.jive.nl/>
-- P.O.Box 2, 7990 AA Dwingeloo, The Netherlands
--
-- This program is free software: you can redistribute it and/or modify
-- it under the terms of the GNU General Public License as published by
-- the Free Software Foundation, either version 3 of the License, or
-- (at your option) any later version.
--
-- This program is distributed in the hope that it will be useful,
-- but WITHOUT ANY WARRANTY; without even the implied warranty of
-- MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-- GNU General Public License for more details.
--
-- You should have received a copy of the GNU General Public License
-- along with this program.  If not, see <http://www.gnu.org/licenses/>.
--
-------------------------------------------------------------------------------

LIBRARY IEEE;
USE IEEE.std_logic_1164.ALL;


ENTITY tb_tb_dp_fifo_fill_sc IS
END tb_tb_dp_fifo_fill_sc;


ARCHITECTURE tb OF tb_tb_dp_fifo_fill_sc IS
BEGIN

  -- > as 10
  -- > run 300 us                 --> OK

  -- Try FIFO settings : GENERIC MAP (g_dut_use_bsn, g_dut_use_empty, g_dut_use_channel, g_dut_use_sync, g_dut_fifo_rl, g_dut_fifo_size, g_dut_fifo_fill)
  
  u_rl_1_fill_0          : ENTITY work.tb_dp_fifo_fill_sc GENERIC MAP (FALSE, FALSE, FALSE, FALSE, 1, 64, 0);   -- no fill ==> dp_fifo_sc
  u_rl_1_fill_1          : ENTITY work.tb_dp_fifo_fill_sc GENERIC MAP (FALSE, FALSE, FALSE, FALSE, 1, 64, 1);
  u_rl_1_fill_3          : ENTITY work.tb_dp_fifo_fill_sc GENERIC MAP (FALSE, FALSE, FALSE, FALSE, 1, 64, 3);
  u_rl_1_fill_30         : ENTITY work.tb_dp_fifo_fill_sc GENERIC MAP (FALSE, FALSE, FALSE, FALSE, 1, 64, 30);
  u_rl_1_fill_size       : ENTITY work.tb_dp_fifo_fill_sc GENERIC MAP (FALSE, FALSE, FALSE, FALSE, 1, 64, 64);
  u_rl_1_fill_30_bsn     : ENTITY work.tb_dp_fifo_fill_sc GENERIC MAP (TRUE,  FALSE, FALSE, FALSE, 1, 64, 30);
  u_rl_1_fill_30_empty   : ENTITY work.tb_dp_fifo_fill_sc GENERIC MAP (FALSE, TRUE,  FALSE, FALSE, 1, 64, 30);
  u_rl_1_fill_30_channel : ENTITY work.tb_dp_fifo_fill_sc GENERIC MAP (FALSE, FALSE, TRUE,  FALSE, 1, 64, 30);
  u_rl_1_fill_30_sync    : ENTITY work.tb_dp_fifo_fill_sc GENERIC MAP (FALSE, FALSE, FALSE, TRUE,  1, 64, 30);
  u_rl_1_fill_30_all     : ENTITY work.tb_dp_fifo_fill_sc GENERIC MAP (TRUE,  TRUE,  TRUE,  TRUE,  1, 64, 30);
  
  u_rl_0_fill_0          : ENTITY work.tb_dp_fifo_fill_sc GENERIC MAP (FALSE, FALSE, FALSE, FALSE, 0, 64, 0);   -- no fill ==> dp_fifo_sc
  u_rl_0_fill_1          : ENTITY work.tb_dp_fifo_fill_sc GENERIC MAP (FALSE, FALSE, FALSE, FALSE, 0, 64, 1);
  
END tb;
