from myhdl import *
from mux import mux
from block_gen import block_gen

def muxed_block_gens(mux_out, reset, clock):

    mux_sel, bg0_en, bg1_en = [Signal(bool(0)) for i in range(3)]
    bg0_out, bg1_out = [Signal(intbv(0)[2:]) for i in range(2)]

    bg0 = block_gen(bg0_out, bg0_en, clock, reset, n=4)
    bg1 = block_gen(bg1_out, bg1_en, clock, reset, n=4)
    my_mux = mux(mux_out, bg0_out, bg1_out, mux_sel)

    return bg0, bg1, my_mux


def convert():

    mux_out = Signal(intbv(0)[2:])
    clock = Signal(bool(0))
    reset = ResetSignal(0, active=0, async=True)
    toVerilog(muxed_block_gens, mux_out, reset, clock)
    toVHDL(muxed_block_gens, mux_out, reset, clock)

convert()
