# Our base class
class module(object):
    def __init__(self, name):
        self.name = name
        print 'Instantiating', self.name
        print '. (paste instance + signal declarations in VHDL file)'
    
    #'>' operator: Connect
    def __gt__(self, other):
        return self.__connect__(other)
    def __connect__(self, other):
        if hasattr(other, 'snk'):
            other.snk = self.src
            other.func()
            print 'connecting', self.name, 'to', other.name 
            print '. (paste signal assignments in VHDL file)'
            return other
        else:
            print 'Error: downstream component', other.name, 'does not have snk'

    def func(self):
        return None

# Components inheriting our base class
class dp_src(module):
    def __init__(self):
        module.__init__(self, 'dp_src')
        # Call func on init as this component does not require snk input to produce src
        self.func()        

    def func(self):  # Declare that this module has a src and provide the func that models it
        self.src = [0,1,2,3,4,5,6]

class dp_incr(module):
    def __init__(self):
        module.__init__(self, 'dp_incr')
        self.snk = [] # Declare that this module has a snk

    def func(self): # Declare that this module has a src and the func that models it
        src = []
        for word in self.snk:
            src.append(word+10)
        self.src = src

class dp_snk(module):
    def __init__(self):
        module.__init__(self, 'dp_snk')
        self.snk = [] # Declare that this module has a snk

    def func(self):
        self.ram = self.snk



# Basic concept for a top-level Python design description
# =============================================================

# Instantiatiations (paste instance + signal declarations in VHDL file)
a=dp_src()
b=dp_incr()
c=dp_snk()
print ''

# system flow desciption (for functional modeling and pasting signal assignments in VHDL file)
# . The '>' operator is overloaded and calls module.connect().
a>b>c
print ''

# Simple example of functional modeling
print 'a.src:', a.src # src output is defined by a.func()
print 'b.snk:', b.snk 
print 'b.src:', b.src # src output is defined by b.func()
print 'c.snk:', c.snk

