import multiprocessing

def sink(p_snk,p_src):
    p_src.close() # Close this local connection to source end of the pipe
    while True:
        try:
            item = p_snk.recv()
        except EOFError:
            break
        print item  

def source(sequence, output_p):
    for item in sequence:
        output_p.send(item)

if __name__ == '__main__':
    # Create pipe and return connections to the source and sink sides of the pipe
    p_snk, p_src = multiprocessing.Pipe(duplex=False)

    my_sink = multiprocessing.Process(target=sink, args=(p_snk, p_src))
    my_sink.start()

    # Close this local connection to the sink end of the pipe
    p_snk.close()

    # Go produce some data
    data = xrange(100)
    source(data, p_src)
    
    # Close the pipe
    p_src.close()
